﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private manager As BleManager2
	Public connectedCentrals As Map
	Private peripheral As BlePeripheral2
	Public NotAvailable As Boolean
	Private NativeMe As JavaObject
	
	Private b() As Byte
End Sub

Sub Service_Create
	NativeMe.InitializeContext
	manager.Initialize("manager")
	connectedCentrals.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub


Private Sub Manager_StateChanged (State As Int)
	Dim bc As ByteConverter
	If State <> manager.STATE_POWERED_ON Then
		ToastMessageShow("Please enable Bluetooth", True)
		NotAvailable = True
	Else
		peripheral.Initialize("peripheral", manager)
        
		Dim bb As B4XBytesBuilder 'B4XCollections
		bb.Initialize
		bb.Append(Array As Byte(0x02, 0x15))
		Dim bc As ByteConverter
		bb.Append(bc.HexToBytes("0CF052C297CA407C84F8B62AAC4E9020"))
		bb.Append(Array As Byte(0, 9, 0, 6, 0xb5))
		b = bb.ToArray
		peripheral.ManufacturerData = CreateMap(76: b )
		Log(b.Length)
		If peripheral.IsPeripheralSupported = False Then
			ToastMessageShow("Peripheral mode not supported.", True)
			NotAvailable = True
		Else
			Dim AdvertiseDataBuilder As JavaObject
			AdvertiseDataBuilder = AdvertiseDataBuilder.InitializeNewInstance("android.bluetooth.le.AdvertiseData.Builder", Null)
			If peripheral.ManufacturerData.IsInitialized Then
				For Each key As Int In peripheral.ManufacturerData.Keys
					Dim value() As Byte = peripheral.ManufacturerData.Get(key)
					AdvertiseDataBuilder.RunMethod("addManufacturerData", Array(key, value))
				Next
			End If
			Dim AdvertiseData As JavaObject = AdvertiseDataBuilder.RunMethod("build", Null)
			Dim AdvertiseSettingsBuilder As JavaObject
			AdvertiseSettingsBuilder = AdvertiseSettingsBuilder.InitializeNewInstance("android.bluetooth.le.AdvertiseSettings.Builder", Null)
			AdvertiseSettingsBuilder.RunMethod("setConnectable", Array(False))
			Dim callback As JavaObject
			callback.InitializeNewInstance(Application.PackageName & ".starter$MyCallback", Null)
			Dim jo As JavaObject = peripheral
			jo.GetFieldJO("advertiser").RunMethod("startAdvertising", Array(AdvertiseSettingsBuilder.RunMethod("build", Null), _
				AdvertiseData, Null, callback))
		End If
		
	End If
End Sub



'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

#if Java
import android.bluetooth.le.*;
public static class MyCallback extends AdvertiseCallback {
 public void onStartSuccess(AdvertiseSettings settingsInEffect) {
 		BA.Log("Started successfully");
    }
    public void onStartFailure(int errorCode) {
	BA.Log("failed to start: " + errorCode);
    }
}
#End If

